#include "pkgs.h"
#include "test-proxy.h"
#include "thread.h"
#include "util.h"
#include "tsocket.h"

pid_t child_pid;

void launch_proxy(char *progname)

{
        char   server_port_str[10], proxy_port_str[10];
        int    ret;
	pid_t  pid;
	printf("trying to launch tcpproxy: %s localhost %d listen port %d\n",progname, SERVER_PORT, client_port);
	if ((pid = fork()) < 0) {
		prerror("fork");
		exit (-1);
	} else if (pid == 0) {
		char name[256];
		int  fd, my_pid;
		strcpy (name, "output");
		
		printf("opening output");

		fd = open(name, O_WRONLY | O_CREAT | O_APPEND, 0777);

		if (fd < 0) {
			fatal ("open: %s %s\n", name, strerror(errno));
		}


		dup2(fd, 1);
		dup2(fd, 2);
		
		close (fd);

		my_pid = getpid();
		if (setpgid(my_pid, my_pid) < 0)
			prerror ("setpgrp");

		sprintf (server_port_str, "%d", SERVER_PORT);
		sprintf (proxy_port_str, "%d", client_port);
		ret = execl(progname, "proxy", "localhost", server_port_str, 
			    proxy_port_str, NULL);
		prerror ("execl");

	}
	child_pid = pid;
}

void kill_proxy()

{
	kill (-child_pid, SIGKILL);
	waitpid(-1, NULL, 0);
	client_port++;
	saddr.sin_port = htons(client_port);
}


static void client_thread(void *arg)

{

}

static void server_thread(void *arg)

{

}

void wait_for_proxy_start(char *proxy_name)

{
	phase_info_t  info = { client_thread, server_thread, 1, 1 };
	phase_ret_t   ret;
	int  iter = 0, flag;


	flag = error_set(0);
	while (++iter < 10) {
		do_phase(&info, &ret);

		if (ret.succeeded) {
			error_set(flag);
			return;
		}

		sleep(1);
	}
	error_set(flag);

	kill_proxy();
	fatal("Unable to start proxy %s\n", proxy_name);
}

#if 0
void wait_for_proxy_start(char *proxy_name)

{
	int  s, ret, flag;
	int  iter = 0;

	while (++iter < 3) {
		s  = tsocket(AF_INET, SOCK_STREAM, 0);

		if (s < 0) {
			prerror("socket");
			exit (-1);
		}

		talarm(10);
		ret = tconnect(s, &saddr, sizeof(saddr));
		talarm(0);
			
		if (ret < 0) {
			if (errno != EINTR) {
				tclose (s);
				sleep(2);
				continue;
			}
			break;
		} else {
			error_flag = 0;
			break;
		}

	}

	tclose (s);

}
#endif

int restart_proxy(char *proxy_name)

{
	if (child_pid) {
		kill_proxy();
		child_pid = 0;
	}

	launch_proxy(proxy_name);

	error_flag = 0;

	wait_for_proxy_start(proxy_name);

	if (error_flag) {
		printf ("Proxy failed to start..\n");
		kill_proxy();
		return (-1);
	}

	return (0);
}
