
/*
 * Heavily based on BSD sys/queue.h
 */

#define DEQUE_HEAD(name, type)			\
struct name {					\
	struct type *first;  /* first element */	\
	struct type *last;  /* last element */	\
}
	
#define DEQUE_ENTRY(type)				\
struct {						\
	struct type *next;  /* next element */		\
	struct type *prev;  /* previous element */	\
}

#define DEQUE_FIRST(head)          ((head)->first)
#define DEQUE_NEXT(elm, field)     ((elm)->field.next)
#define DEQUE_LAST(head)           ((head)->last)

#define DEQUE_INSERT_HEAD(head, elm, field) do {		\
	if (((elm)->field.next = (head)->first) != NULL)	\
		(head)->first->field.prev = (elm);		\
	else							\
		(head)->last = (elm);				\
	(head)->first = (elm);					\
} while (0)

#define DEQUE_INSERT_TAIL(head, elm, field) do {	\
	if (((elm)->field.prev = (head)->last) != NULL)	\
		(head)->last->field.next = (elm);		\
	else						\
		(head)->first = (elm);			\
	(head)->last = (elm);				\
} while (0)

#define DEQUE_REMOVE(head, elm, field) do {				\
	if ((elm)->field.next)						\
		(elm)->field.next->field.prev = (elm)->field.prev;	\
	else								\
		(head)->last = (elm)->field.prev;			\
	if ((elm)->field.prev)						\
		(elm)->field.prev->field.next = (elm)->field.next;	\
	else								\
		(head)->first = (elm)->field.next;			\
	(elm)->field.prev = (elm)->field.next = NULL;			\
} while (0)
