#ifndef __THREAD_H__

#define __THREAD_H__

#include "deque.h"

/* Possible states of a thread; */
#define		FREE		0x0
#define		RUNNING	        0x1
#define		RUNNABLE	0x2
#define		WAITING	        0x4

#define 	STACK_SIZE	32768
#define         BODY_OFFSET     200
#define		MAX_THREAD	120

#if __sparc__
#define         RETURN_OFFSET   8
#endif
#if __i386__
#define         RETURN_OFFSET   4
#endif

typedef struct thread thread_t, *thread_p;
DEQUE_HEAD(threadq, thread);
typedef struct threadq threadq_t, *threadq_p;
typedef threadq_t condition_t, *condition_p;

typedef void (*threadproc)(void *);

void thread_init(void);
thread_p thread_create(void (*func)(void *), void *);
void thread_print(thread_p);
void thread_alert(thread_p thread);
void thread_broadcastalert(void);
void thread_alarm(thread_p thread, int sec);

int condition_wait(condition_p var);
void condition_signal(condition_p var);
void condition_broadcast(condition_p var);


int fd_sleep (int fd, int write);
void fd_shutdown (int fd, int how);


extern thread_p current_thread;
#define thread_current_thread() current_thread
#define talarm(sec) thread_alarm(current_thread, sec)

#define FD_MAX  64
#define EALARM (200)


#endif /* __THREAD_H__ */


