#define ASENTRY(fn)        \
       .global fn	;  \
fn:

/* Please both Solaris and SunOS */
#define ENTRY(x)                  \
        .align 4	;  \
        ASENTRY(_##x)	;  \
        ASENTRY(x)

#ifdef __sparc__
	
#define ST_FLUSH_WINDOWS 3
#define WINDOWSIZE 64
#define STACK_ALIGN     8
#define SA(X)   (((X)+(STACK_ALIGN-1)) & ~(STACK_ALIGN-1))


        .text

ENTRY(thread_switch)
	  save    %sp,-SA(WINDOWSIZE),%sp
	  ta      ST_FLUSH_WINDOWS
          std     %fp,[%i0]
	  ldd     [%i1],%fp
	  ret
	  restore
	
#endif

#if __i386__

	.text

/* Switch from current_thread to next thread_thread, and make
 * next_thread the current_thread.  Use eax as a temporary register,
 * which should be caller saved. */
ENTRY(thread_switch)
	pushl   %ebp
	movl	%esp, %ebp

	pushl   %ebx
	pushl   %esi
	pushl   %edi

	movl	8(%ebp),%edx
	movl    12(%ebp),%eax
	movl	%esp, (%edx)

	movl	(%eax),%esp

	popl	%edi
	popl	%esi
	popl	%ebx

	popl	%ebp
	ret				/* pop return address from stack */
#endif
