#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <sys/socket.h>

#include <netinet/in.h>

#include <sys/time.h>
#include <sys/types.h>

#include "util.h"
#include "tsocket.h"
#include "thread.h"

void *
xrealloc (void *p, size_t size)
{
  if (!p)
	  p = malloc(size);
  else
	  p = realloc (p, size);

  if (size && !p)
    fatal ("out of memory\n");
  return p;
}



void
fatal (const char *msg, ...)
{
  va_list ap;

  fprintf (stderr, "fatal: ");
  va_start (ap, msg);
  vfprintf (stderr, msg, ap);
  va_end (ap);
  assert(0);
  exit (1);
}


