
#ifndef _UTIL_H_ /* Guard against multiple inclusion */
#define _UTIL_H_ 1

/* Enable stress-tests. */
/* #define SMALL_LIMITS 1 */

#include <sys/types.h>

#if __GNUC__ != 2
/* The __attribute__ keyword helps make gcc -Wall more useful, but
 * doesn't apply to other C compilers.  You don't need to worry about
 * what __attribute__ does (though if you are curious you can consult
 * the gcc info pages). */
#define __attribute__(x)
#endif /* __GNUC__ != 2 */

void fatal (const char *msg, ...) __attribute__ ((noreturn, format (printf, 1, 2)));

/* Malloc-like functions that don't fail. */
void *xrealloc (void *, size_t);
#define xmalloc(size) xrealloc (0, size)
#define xfree(ptr) xrealloc (ptr, 0)
#define bzero(ptr, size) memset (ptr, 0, size)

#endif /* !_UTIL_H_ */
