#include "pkgs.h"
#include "thread.h"
#include "tsocket.h"
#include "util.h"
#include "test-proxy.h"

condition_t var_updated;

static char buf[1024];
int  success = 0;

/* testing proxy by
   varying the role of client-write or server write */

static void client_thread(void *arg)

{
	int cnt, ret, fd;

	fd = (int) arg;
	cnt = 0;

	talarm(30);
	while (cnt<10240) {
		if ((ret = twrite(fd, buf, sizeof(buf))) < 0) {
			prerror ("twrite");
			error_flag = 1;
			goto next;
		}
		cnt += ret;
//		printf("write %d!\n",cnt);
	}
	close(fd);
	if (condition_wait(&var_updated) <0) {
	    printf("client wait interruped!\n");
	    error_flag = 1;
	    success = 0;
	}
	
 next:
	done = 1;
}

static void server_thread(void *arg)

{
	int cnt, ret, fd;

	fd = (int) arg;
	cnt = 0;

	while ((ret = tread(fd, buf, sizeof(buf))) > 0) {
		cnt += ret;
//		printf("read %d!\n",cnt);
	}

	if (cnt >= 10240) {
	    success = 1;
	    condition_signal(&var_updated);
	    return;
	}

	if (ret < 0) {
		error_flag = 1;
		prerror ("Read");
		condition_signal(&var_updated);
		return;
	}

}

void do_phase2()

{
	phase_info_t  info = { client_thread, server_thread, 1, 1};
	phase_ret_t ret; 
	int phase;

	printf ("Phase 2: testing client-write-only-and-server-read-only and vice versa\n");

	for (phase = 0; phase < 2; phase++) {
		success = 0;

		switch (phase) {
		case 0:
			info.client = client_thread;
			info.server = server_thread;
			printf ("%d simultaneous connections(%d total) client write, server read...",
			    info.max_sim, info.max_conn);
	
			break;
		case 1:
			info.client = server_thread;
			info.server = client_thread;
			printf ("%d simultaneous connections(%d total) client read, server write...",
			    info.max_sim, info.max_conn);
			break;
		}

		
		do_phase(&info, &ret);

		if ((!success) || (!ret.succeeded)) {
			printf ("Failed\n");
			restart_proxy(proxy_name);
		} else 
			printf ("Succeeded\n");
      	}

}


