#include "pkgs.h"
#include "thread.h"
#include "tsocket.h"
#include "util.h"
#include "test-proxy.h"

condition_t var_updated;

static char buf[40];
static int  success = 0;

/* testing proxy timeout implementation */
static void client_thread(void *arg)

{
	int cnt, ret, fd;

	fd = (int) arg;
	cnt = 0;

	talarm (20);    
	while (1) {
		if ((ret = twrite(fd, buf, sizeof(buf))) < 0) {
			if (errno == EPIPE) {
				success = 1;
				goto next;
			}else if (errno == ECONNRESET) {
				success = 1;
				goto next;
			}
			/* including errno when alarm signal is raised, i.e. I've successful written for 20 seconds with
			   client/server hanging, timeout implementation must have failed*/
			prerror ("twrite");
			error_flag = 1;
			goto next;
		}
//		fd_sleep(1);
//		printf("%d written %d bytes\n",fd,ret);
	}

 next:
	talarm(0);
	done = 1;
}

static void server_thread(void *arg)

{
	int cnt, ret, fd;

	fd = (int) arg;
	cnt = 0;

	while ((ret = tread(fd, buf, sizeof(buf))) > 0) {
		cnt += ret;
		if (cnt > 10) break;
	}

	if (ret < 0) {
		error_flag = 1;
		prerror ("Read");
		return;
	}

	//tclose(fd);
	//stops reading after finishing reading > 10  bytes, a hanging scenario
	condition_wait(&var_updated);
}

void do_phase3()

{
	phase_info_t  info = { client_thread, server_thread, 1, 1 };
	phase_ret_t ret; 
	int phase;

	printf ("Phase 3: testing hanging server/hanging client\n");

	for (phase = 0; phase < 3; phase++) {
		success = 0;

		switch (phase) {
		case 0:
			info.client = client_thread;
			info.server = server_thread;
			printf ("%d simultaneous connections(%d total) client read, server write...",
				info.max_sim, info.max_conn);

			break;
		case 1:
			info.client = server_thread;
			info.server = client_thread;
			printf ("%d simultaneous connections(%d total) client read, server write...",
				info.max_sim, info.max_conn);

			break;
		case 2:
			info.max_conn = 200;
			printf ("%d simultaneous connections(%d total) client read, server write...",
				info.max_sim, info.max_conn);
			break;
		}

		do_phase(&info, &ret);

		if (!success) {
			printf ("Failed\n");
			kill_proxy();
			restart_proxy(proxy_name);
			break;
		} else 
			printf ("Succeeded\n");
      	}

}


