#include "pkgs.h"
#include "thread.h"
#include "tsocket.h"
#include "util.h"
#include "test-proxy.h"

int free_flag;
int error_flag;
thread_p proxy_waiter;
struct sockaddr_in saddr;
int client_port;

char *sample_buffer;
int   sample_size;
char *proxy_name;

/* 
 * 			Thread code
 */
static void
sigchld (int sig)
{
#if 0
	error_flag = 1;
#endif
	fprintf (stderr, "Proxy down\n");
}

static void
sigintr(int sig)

{
	kill_proxy();
	exit (-1);
}

int main (int argc, char *argv[]) 

{
	int  cnt;
	struct hostent *h;
	struct sigaction sa;
	int test_no = 0;

	thread_init();

	sa.sa_handler = sigchld;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_NOCLDSTOP;
	sigaction (SIGCHLD, &sa, NULL);

	sa.sa_handler = sigintr;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = 0;
	sigaction (SIGINT, &sa, NULL);
 
	printf ("Initializing random buffer...");

	sample_size = 1024 * 20;

	sample_buffer = xmalloc(sample_size);

	for (cnt = 0; cnt < sample_size; cnt++) {
		sample_buffer[cnt] = random();
	}

	printf ("Done\n");

	h = gethostbyname ("localhost");
	if (!h) {
		fprintf (stderr, "Host lookup failed\n");
		exit (-1);
	}

	srandom(time(NULL));
	//client_port = 1024 + random() % 1024;
	client_port = CLIENT_PORT;
	memset (&saddr, 0, sizeof(saddr));
	saddr.sin_family = AF_INET;
	saddr.sin_port = htons(client_port);
	saddr.sin_addr = * (struct in_addr *) h->h_addr;

	if (argc < 2) {
		printf ("Usage: test-proxy proxy-prog [test #]\n");
		printf ("Default operation runs all tests.");
		printf (" There are 6 available tests.\n");
		return;
	}

	if (argc == 3) {
		test_no = atoi(argv[2]);
	}


	proxy_name = argv[1];
	restart_proxy(argv[1]);

	fprintf (stderr, "Starting tests...\n");


	switch (test_no) {
	default:
	case 0:
		do_phase1();
		do_phase2();
		do_phase3();
		break;
	case 1:
		do_phase1();
		break;
	case 2:
		do_phase2();
		break;
	case 3:
		do_phase3();
		break;
	}

	kill_proxy();
	return 0;
}
